package eu.etaxonomy.cdm.api.cache;

import java.util.List;

import net.sf.ehcache.Cache;

import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.Test;

import eu.etaxonomy.taxeditor.remoting.cache.CdmModelCacher;
import eu.etaxonomy.taxeditor.remoting.cache.CdmModelFieldPropertyFromClass;
import eu.etaxonomy.taxeditor.remoting.cache.CdmRemoteCacheManager;


public class CdmModelGetMethodCacherTest {

	private static final Logger logger = Logger.getLogger(CdmModelGetMethodCacherTest.class);


	@Test
	public void cacheGettersTest() {

		CdmModelCacher cmdmc = new CdmModelCacher();

		Cache cdmlibCache = CdmRemoteCacheManager.getInstance().getCdmModelGetMethodsCache();
		List<CdmModelFieldPropertyFromClass> cmgmfcList = cmdmc.getCdmModelGetMethodFromClassList();

		List<Object> keys = cdmlibCache.getKeys();
		Assert.assertEquals(cmgmfcList.size(), keys.size());

		for(CdmModelFieldPropertyFromClass cmgmfc: cmgmfcList) {
			String className = cmgmfc.getClassName();
			Assert.assertTrue(keys.contains(className));
			logger.info("Class Name : " + className + " has been cached");
		}

		//FIXME:Remoting do we need to test this ?
		// this will cause the following tests to fail since all caches are shutdown
		//cdmlibCache.removeAll();
		//CacheManager.create().shutdown();
	}




}
