// $Id$
/**
 * Copyright (C) 2015 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.ui.dialogs;

import java.util.List;

import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.unitils.UnitilsJUnit4;

import eu.etaxonomy.taxeditor.remoting.server.CDMServerException;
import eu.etaxonomy.taxeditor.remoting.source.CdmServerInfo;
import eu.etaxonomy.taxeditor.remoting.source.CdmServerInfo.CdmInstanceInfo;

/**
 * @author cmathew
 * @date 26 Jan 2015
 *
 */

public class CdmServerInfoTest extends UnitilsJUnit4 {

    @Test
    public void pingServersTest() {
        List<CdmServerInfo> servers = CdmServerInfo.getCdmServers();
        for(CdmServerInfo server : servers) {
            server.pingServer();
        }
    }

    // FIXME:Remoting this is an integration test and should be run against a
    //  cdmserver
    @Ignore
    @Test
    public void pingInstancesTest() {
        CdmServerInfo csii = new CdmServerInfo("localhost", "localhost", 8080);
        try {
            csii.refreshInstances();
            List<CdmInstanceInfo> instances = csii.getInstances();
            for(CdmInstanceInfo instance : instances) {
                Assert.assertTrue(csii.pingInstance(instance));
            }
        } catch (CDMServerException e) {
            Assert.fail("Execption should not be thrown here");
        }
    }

    @Test
    public void refreshWrongInstancesTest() {
        CdmServerInfo wrongCsii = new CdmServerInfo("local", "local", 8080);
        try {
            wrongCsii.refreshInstances();
            List<CdmInstanceInfo> instances = wrongCsii.getInstances();
            Assert.fail("Execption should be thrown here");
        } catch (CDMServerException e) {

        }
    }
}
